package org.dromara.work.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.github.yulichang.base.MPJBaseService;
import jakarta.validation.constraints.NotNull;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.work.domain.TpOrder;
import org.dromara.work.domain.bo.OrderRankingBo;
import org.dromara.work.domain.bo.TpOrderBo;
import org.dromara.work.domain.vo.*;

import java.math.BigDecimal;
import java.util.Collection;
import java.util.List;

/**
 * 订单管理Service接口
 *
 * @author Maosw
 * @date 2024-08-12
 */
public interface ITpNewOrderService extends MPJBaseService<TpOrder> {

    /**
     * 客服排行榜
     * @param bo
     * @param pageQuery
     * @return
     */
    TableDataInfo<OrderRankingVo> rankingList(OrderRankingBo bo, PageQuery pageQuery);

    /**
     * 技术排行榜
     * @param bo
     * @param pageQuery
     * @return
     */
    TableDataInfo<OrderRankingVo> rankingListJS(OrderRankingBo bo, PageQuery pageQuery);


    /**
     * 客服排行榜统计
     * @param bo
     * @return
     */
    OrderRankingSumVo rankingListKFSum(OrderRankingBo bo);

    /**
     * 技术排行榜统计
     * @param bo
     * @return
     */
    OrderRankingSumVo rankingListJSSum(OrderRankingBo bo);

    /**
     * 客户下单排行榜
     * @param bo
     * @param pageQuery
     * @return
     */
    TableDataInfo<OrderRankingVo> khRankingList(OrderRankingBo bo, PageQuery pageQuery);

    /**
     * 客户下单排行榜统计
     * @param bo
     * @return
     */
    OrderRankingSumVo khRankingListSum(OrderRankingBo bo);

    /**
     * 分页查询订单管理列表
     *
     * @param bo 订单管理
     * @return 订单管理
     */
    IPage<TpOrderVo> selectPageList(TpOrderBo bo, PageQuery pageQuery);

    /**
     * 根据id查询订单详情
     * @param id
     * @return
     */
    TpOrderVo queryById(Long id);

    /**
     * 客服首页统计
     * @return
     */
    IndexSumVo getKfTarget();

    /**
     * 技术首页统计
     * @return
     */
    IndexSumVo getJsTarget();
}
